#include <stdio.h>

#define PRJNAME      "ProjectX City Location Editor"
#define PRJVER       "0.12"
#define PRJDATE      "4.14.99"

typedef struct CITY
{
   char name[15];
   int x;      //x location on the overworld
   int y;
   int ex;     //exit location
   int ey;
   int plx;    //where the player starts
   int ply;
   char datfile[20];
} CityType;

CityType city[100]; 


void str_toupper(char strng[])
{
   int i=0;
   char to_upper(char);

   while(strng[i] != '\0')
   {
      strng[i] = toupper(strng[i]);
      i++;
   }
}

int LoadFile()
{
   FILE *infile;

   infile=fopen("DAT\\CITYLOC.DAT","rb");
   if(infile==NULL)
   {
      printf("I'm sory, that datfile can't be loaded\n");
      exit(1);
   }

   fread(&city,sizeof(city),1,infile);

   fclose(infile);
   return(0);
}

int SaveFile()
{
   FILE *outfile;

   outfile=fopen("DAT\\CITYLOC.DAT","wb");
   if(outfile==NULL)
   {
      printf("I'm sorry, that datfile can't be saved\n");
      exit(1);
   }

   fwrite(&city,sizeof(city),1,outfile);

   fclose(outfile);
   return(0);
}


int main()
{
   char TmpKey, TmpChoice;
   int tempfoo,foo,temp1,temp2,temp3;
   char tempstring[15];

   printf("\n%s version %s\nBuild Date: %s\n",PRJNAME,PRJVER,PRJDATE);

   tempfoo=0;
   while(tempfoo==0)
   {
      printf("\n\nMain Menu\n");
      printf("---------\n");
      printf("1.  Load DATFile\n");
      printf("2.  View current DATFile information\n");
      printf("3.  Change a record in the DATFile\n");
      printf("4.  Delete a record\n");
      printf("5.  Save DATFile\n");
      printf("0.  Exit program\n");
      printf("\nYour Choice: ");
      TmpKey=getch();
      switch(TmpKey)
      {
         case '0':
            exit(0);
            break;
         case '1':
            LoadFile();
            printf("\n\n         ---***--- File successfully loaded ---***---");
            break;
         case '5':
            SaveFile();
            printf("\n\n         ---***--- File successfully saved ---***---");
            break;
         case '2':
            printf("\nView current DATfile information");
            printf("\n--------------------------------");
            for(temp1=0;temp1<=90;temp1+=10)
            {
               printf("\n");
               for(temp2=0;temp2<10;temp2++)
               {
                  printf("#%i %-15s X:%-3i Y:%-3i PLX:%-3i PLY:%-3i EX:%-3i EY:%-3i %s\n",(temp1+temp2),city[temp1+temp2].name,city[temp1+temp2].x,city[temp1+temp2].y,city[temp1+temp2].plx,city[temp1+temp2].ply,city[temp1+temp2].ex,city[temp1+temp2].ey,city[temp1+temp2].datfile);
               }
               printf("\n          ---**--- Press any key to continue ---***---\n");
               foo=getch();
            }
            break;
         case '3':
            printf("\n\n\nChange a record in the DATFile");
            printf("\n------------------------------");
            printf("\nRecord Number: ");
            scanf("%i",&temp1);
            printf("\n                Current Name: %s\n",city[temp1].name);
            printf("                    New Name: ");
            scanf("%s",&tempstring);
            strcpy(city[temp1].name,tempstring);

            printf("\nCurrent Overworld X Location: %i\n",city[temp1].x);
            printf("    New Overworld X Location: ");
            scanf("%i",&temp2);
            city[temp1].x=temp2;

            printf("\nCurrent Overworld Y Location: %i\n",city[temp1].y);
            printf("    New Overworld Y Location: ");
            scanf("%i",&temp2);
            city[temp1].y=temp2;

            printf("\nPlayer's Starting X Location: %i\n",city[temp1].plx);
            printf("     New Starting X Location: ");
            scanf("%i",&temp2);
            city[temp1].plx=temp2;

            printf("\nPlayer's Starting Y Location: %i\n",city[temp1].ply);
            printf("     New Starting Y Location: ");
            scanf("%i",&temp2);
            city[temp1].ply=temp2;

            printf("\n     MAP's Exit X coordinate: %i\n",city[temp1].ex);
            printf("         New Exit X Location: ");
            scanf("%i",&temp2);
            city[temp1].ex=temp2;

            printf("\n     MAP's Exit X coordinate: %i\n",city[temp1].ey);
            printf("         New Exit Y Location: ");
            scanf("%i",&temp2);
            city[temp1].ey=temp2;

            printf("\n             Current DATFile: %s\n",city[temp1].datfile);
            printf("                 New DATFile: ");
            scanf("%s",&tempstring);
            str_toupper(tempstring);
            strcpy(city[temp1].datfile,tempstring);

            printf("String in Record %i: %s\n",temp1,city[temp1].name);
            break;
         case '4':
            printf("\nDelete a record in the DATFile");
            printf("\n------------------------------");
            printf("\nRecord Number: ");
            scanf("%i",&temp1);
            printf("\nAre you sure you want to do this? ");
            TmpChoice=getch();
            TmpChoice=toupper(TmpChoice);
            if(TmpChoice!='Y')
            {
               printf("\n\n            ---**--- Record #%i was NOT Deleted ---***---\n",temp1);
               break;
            }
            strcpy(city[temp1].name,"");
            city[temp1].x=0;
            city[temp1].y=0;
            city[temp1].ex=0;
            city[temp1].ey=0;
            city[temp1].plx=0;
            city[temp1].ply=0;
            strcpy(city[temp1].datfile,"");
            printf("\n\n          ---**--- Record #%i Successfully Deleted ---***---\n",temp1);
            break;
      }
   }
   return(0);
}

